<?php
/**
 * @project    : yabandpay
 * @description:
 * @user       : PersiLiao
 * @email      : persi@sixsir.com
 * @date       : 2018/12/2
 * @time       : 22:15
 */

namespace YaBandPay\PersiLiao;

/**
 * Class Cryptography
 *
 * @package YaBandPay
 * @description
 * @version 1.0.0
 */
class Cryptography
{
    /**
     * @var string
     */
    private $token;
    /**
     * @var string
     */
    private $algorithm;
    /**
     * @var string
     */
    private $algo;

    public function __construct($token, $algorithm = 'hash_hmac', $algo = 'sha256')
    {
        $this->token = $token;
        $this->algorithm = $algorithm;
        $this->algo = $algo;
    }

    public function encrypt($param, $sort = false)
    {
        switch($this->algorithm){
            case 'hash_hmac':
                {
                    switch($this->algo){
                        case 'sha256':
                            {
                                $tmp = [];
                                $data = empty($param['data']) ? [] : $param['data'];
                                unset($param['data']);
                                foreach ($data as $k => $v){
                                    $tmp[$k] = $v;
                                }
                                foreach ($param as $k => $v){
                                    $tmp[$k] = $v;
                                }
                                ksort($tmp);
                                $key_tmp = [];
                                foreach ($tmp as $k => $v){
                                    $key_tmp[] = $k . '=' . $v;
                                }

                                return hash_hmac('sha256', implode('&', $key_tmp), $this->token);
                            }
                    }
                }
        }
        throw new \InvalidArgumentException('Please choose a normal encryption algorithm .');
    }

    /**
     * verify
     *
     * @param $data
     * @return bool
     */
    public function verify($data, $sort = true)
    {
        $sign = $this->encrypt($data['data'], $sort);
        return $data['sign'] === $sign;
    }

    /**
     * @return string
     */
    public function getToken()
    {
        return $this->token;
    }

    /**
     * @param string $token
     */
    public function setToken($token)
    {
        $this->token = $token;
    }

    /**
     * @return string
     */
    public function getAlgorithm()
    {
        return $this->algorithm;
    }

    /**
     * @param string $algorithm
     */
    public function setAlgorithm($algorithm)
    {
        $this->algorithm = $algorithm;
    }

    /**
     * @return string
     */
    public function getAlgo()
    {
        return $this->algo;
    }

    /**
     * @param string $algo
     */
    public function setAlgo($algo)
    {
        $this->algo = $algo;
    }
}